﻿-- Author      : Nogarder
-- Create Date : 2012/4/7 15:25:27
NPA.FrameMacro={}
--
local NPA_GetTime=NPA.GetTime
local NPA_RunFunc=NPA.RunFunc
local NPA_FrameMacro_FrameTimer={}
--timer
--clear up timer data for reuse of other purpose
NPA.FrameMacro.ResetFrameTimer=function(frame)
	frame:SetScript("OnUpdate",nil)
	local data=NPA_FrameMacro_FrameTimer[frame]
	if(data)then
		data.StartTime=nil
		data.EndTime=nil
		data.Length=nil
		data.TimerEndFunc=nil
		data.OnUpdateFunc=nil
	end
end
--timer on update
local NPA_FrameMacro_TimerOnUpdate=function(frame)
	local nTime=NPA_GetTime()
	local data=NPA_FrameMacro_FrameTimer[frame]
	if(nTime>data.EndTime)then
		NPA_RunFunc(data.TimerEndFunc)
		--also hide it
		--frame:Hide()
	else
		NPA_RunFunc(data.OnUpdateFunc,nTime,data)
	end
end
--
NPA.FrameMacro.SetFrameTimer=function(frame,starttime,endtime,onupdatefunc,timerendfunc)
	frame:SetScript("OnUpdate",NPA_FrameMacro_TimerOnUpdate)
	--only create new table when not exists, this should save some resources
	if(not NPA_FrameMacro_FrameTimer[frame])then
		NPA_FrameMacro_FrameTimer[frame]={
			StartTime=starttime,
			EndTime=endtime,
			Length=endtime-starttime,
			TimerEndFunc=timerendfunc,
			OnUpdateFunc=onupdatefunc
		}
	else
		local data=NPA_FrameMacro_FrameTimer[frame]
		data.StartTime=starttime
		data.EndTime=endtime
		data.Length=endtime-starttime
		data.TimerEndFunc=timerendfunc
		data.OnUpdateFunc=onupdatefunc
	end
end