﻿-- Author      : Nogarder
-- Create Date : 2013/4/25 16:16:23
NPA_Options.RegisterPageFunc("ProfileManager",function()
	local pairs=pairs
	local table_insert=table.insert
	--localization
	local Localization=NPA_Options.Localization.PagesMainProfileManager
	local Tooltips=Localization.Tooltips
	---
	local parent=NPA_Options.MainFrame
	local EntryName
	--
	local main=NPA_Options.Template.CreateFrameWithBar(parent,nil,410,320,nil,nil,nil)
	main:Hide()
	--
	local page=main.Frame
	local scroll=main.Scroll
	local Selected
	--
	--save
	local savebutton=NPA_Options.Template.CreateButton(page,85,15,Localization["Save"])
	savebutton:SetPoint("TOPLEFT",page,"TOPLEFT",5,-5)
	NPA_Options.Template.SetTooltips(Tooltips["Save"],savebutton)
	--copy
	local copybutton=NPA_Options.Template.CreateButton(page,85,15,Localization["Copy"])
	copybutton:SetPoint("LEFT",savebutton,"RIGHT",5,0)
	NPA_Options.Template.SetTooltips(Tooltips["Copy"],copybutton)
	--rename
	local renamebutton=NPA_Options.Template.CreateButton(page,85,15,Localization["Rename"])
	renamebutton:SetPoint("LEFT",copybutton,"RIGHT",5,0)
	NPA_Options.Template.SetTooltips(Tooltips["Rename"],renamebutton)
	--delete
	local removebutton=NPA_Options.Template.CreateButton(page,40,15,Localization["Remove"])
	removebutton:SetPoint("LEFT",renamebutton,"RIGHT",5,0)
	NPA_Options.Template.SetTooltips(Tooltips["Remove"],removebutton)
	--load
	local loadbutton=NPA_Options.Template.CreateButton(page,85,15,Localization["Load"])
	loadbutton:SetPoint("LEFT",removebutton,"RIGHT",5,0)
	NPA_Options.Template.SetTooltips(Tooltips["Load"],loadbutton)
		--
	local selectlist=NPA_Options.Template.CreateSelectList(page,380,270)
	selectlist:SetPoint("TOPLEFT",savebutton,"BOTTOMLEFT",0,-5)
	selectlist.Frame:EnableMouse(false)
	selectlist:EnableMouse(false)
	--
	selectlist.ButtonClickFunc=function(button)
		Selected=button.Value
		NPA_Options.Template.EnableButton(copybutton)
		NPA_Options.Template.EnableButton(removebutton)
		NPA_Options.Template.EnableButton(loadbutton)
		NPA_Options.Template.EnableButton(renamebutton)
	end
	--
	local UpdateList=function()
		local data={}
		for name,_ in pairs(NPA_Profile)do
			table_insert(data,{Text=name,Value=name})
		end
		NPA_Options.Template.UpdateSelectList(selectlist,data)
		--
		Selected=nil
		NPA_Options.Template.SetSelectListFocus(selectlist,nil)
		NPA_Options.Template.DisableButton(copybutton)
		NPA_Options.Template.DisableButton(removebutton)
		NPA_Options.Template.DisableButton(loadbutton)
		NPA_Options.Template.DisableButton(renamebutton)
	end
	--

	local FindName=function(list,name)
		for _,button in pairs(list.Buttons)do
			if(button:IsShown() and button.Text==name)then
				return true
			end
		end
	end
	--
	local CheckName=function(list,name)
		local newname=name
		if(FindName(list,newname))then
			local i=1
			while(FindName(list,newname))do
				newname=name.." ("..i..")"
				i=i+1
			end
		end
		return newname
	end
	--
	savebutton:HookScript("OnMouseUp",function()
		local inputbox=NPA_Options.Template.SetInputBox(main,Localization["InputName"],UnitName("player").."("..date()..")")
		inputbox.CallBackFunc=function(name)
			local name=CheckName(selectlist.Frame,(name or ""))
			NPA_Profile[name]=CopyTable(NPA_Setting)
			print("["..name.."]"..Localization["Saved"])
			UpdateList()
		end
		inputbox:SetPoint("BOTTOM",savebutton,"TOP",10,0)
	end)
	loadbutton:HookScript("OnMouseUp",function()
		if(Selected)then
			local msgbox=NPA_Options.Template.SetMsgBox(main,Localization["SettingWillLose"],function()
				NPA_Setting=CopyTable(NPA_Profile[Selected])
				print("["..Selected.."]"..Localization["Loaded"])
				UpdateList()
				--fire event
				NPA.EventHandler.FireEvent(6,"ProfileManager_ProfileLoaded")
			end)
			msgbox:SetPoint("BOTTOM",loadbutton,"TOP",10,0)
		end
	end)
	copybutton:HookScript("OnMouseUp",function()
		if(Selected)then
			print("OnCopy")
			local name=CheckName(selectlist.Frame,Selected)
			print(name)
			NPA_Profile[name]=CopyTable(NPA_Profile[Selected])
			print("["..name.."]"..Localization["Copyed"])
			UpdateList()
		end
	end)
	--delete
	removebutton:HookScript("OnMouseUp",function()
		if(Selected)then
			local msgbox=NPA_Options.Template.SetMsgBox(main,Localization["ConfirmRemove"],function()
				NPA_Profile[Selected]=nil
				print("["..Selected.."]"..Localization["Removed"])
				UpdateList()
			end)
			msgbox:SetPoint("BOTTOM",removebutton,"TOP",10,0)
		end
	end)
	--rename
	renamebutton:HookScript("OnMouseUp",function()
		if(Selected)then
			local inputbox=NPA_Options.Template.SetInputBox(main,Localization["InputName"],Selected)
			inputbox.CallBackFunc=function(name)
				local name=CheckName(selectlist.Frame,(name or ""),Selected)
				NPA_Profile[name]=NPA_Profile[Selected]
				NPA_Profile[Selected]=nil
				print("["..name.."]"..Localization["Saved"])
				UpdateList()
			end
			inputbox:SetPoint("BOTTOM",renamebutton,"TOP",10,0)
		end
	end)
	--
	main.OnSetFunc=function()
		UpdateList()
	end
	--
	NPA_Options.RegisterPage("ProfileManager",main)

end)